//TODO This is a quick hack to get something working. Should rewrite.
var deliciousService = {
  tagDOM: null,
  setTags: function(tagXML) {
    this.tagDOM = new DOMParser().parseFromString(tagXML, "text/xml");
  },
  getTags: function() {
    return this.tagDOM;
  }
};

var gUsername = "";

var myObserver = {
  observe: function(subject,topic,data) {
    switch (topic) {
      case "ext:delicious:defaultUserChanged":
        gUsername = data;
        break;
      case "ext:delicious:tagxmlForDefaultUser":
        deliciousService.setTags(data);
        clearTags();
        loadTags();
        break;
    }
  }
};

/**
 * When the sidebar is first loaded, load the user's tags.
 */
function onLoad() {
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(myObserver,"ext:delicious:defaultUserChanged",false);
    observerService.addObserver(myObserver,"ext:delicious:tagxmlForDefaultUser",false);
    observerService.notifyObservers(null,"ext:delicious:sidebarLoaded","");
    window.onunload = function() {
      observerService.removeObserver(myObserver,"ext:delicious:defaultUserChanged");
      observerService.removeObserver(myObserver,"ext:delicious:tagxmlForDefaultUser");
    };
}

/**
 * Retrieves user's tags from the del.icio.us server.
 */
function loadTags()
{
    try
    {
        var tagsTree = document.getElementById('delicious-sidebar-tags-tree');
        var xmlDOM = deliciousService.getTags();
        if (xmlDOM == false || xmlDOM == null) {
            return;
        }

        var root = xmlDOM.documentElement;
        var myTags = root.getElementsByTagName("tag");
        
        var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
        RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);
        
        var RDFC = Components.classes['@mozilla.org/rdf/container;1'].getService();
        RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);
        
        var RDFCUtils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService();
        RDFCUtils = RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);
        
        var ds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance();
        ds = ds.QueryInterface(Components.interfaces.nsIRDFDataSource);
        
        // create our root nodes
        var rootNode = RDF.GetResource("urn:root");
        var sequenceNode = RDF.GetResource("urn:root:seq");
        // Root node in tree
        ds.Assert(rootNode, RDF.GetResource("http://delicious.mozdev.org/RDF#tags"), sequenceNode, true);
        
        RDFCUtils.MakeSeq(ds, sequenceNode);
        RDFC.Init(ds, sequenceNode);
        
        tagsTree.database.AddDataSource(ds);
        
        for (var i = 0; i < myTags.length; i++) 
        {
            var tagName = myTags[i].getAttribute("tag");
            var count = myTags[i].getAttribute("count");
            var countSort = leftPad(myTags[i].getAttribute("count"));
            
            var newURI = "urn:root:file:" + i;

            // add the new element
            RDFC.AppendElement(RDF.GetResource(newURI));
            
            ds.Assert(RDF.GetResource(newURI),
                RDF.GetResource("http://delicious.mozdev.org/RDF#name"),
                RDF.GetLiteral(tagName), true);
            
            ds.Assert(RDF.GetResource(newURI),
                RDF.GetResource("http://delicious.mozdev.org/RDF#count"),
                RDF.GetLiteral(count), true);
            
            // "countSort" is used as a hidden column that allows the "count"
            // column to be sorted properly (numerically instead of
            // lexically). Padding the number makes the two equivalent, but
            // you don't want to *see* the padded version.
            ds.Assert(RDF.GetResource(newURI),
                RDF.GetResource("http://delicious.mozdev.org/RDF#countSort"),
                RDF.GetLiteral(countSort), true);
        }
        tagsTree.builder.rebuild();
    }
    catch(e) { alert("Error loading tags: "+e); }
}

function leftPad(number)
{
    var padded=number;
    while(padded.length<5) padded="0"+padded;
    return(padded);
}

function clearTags()
{
    var tree = document.getElementById('delicious-sidebar-tags-tree');
    clearTree(tree);
}

function reloadTags()
{
    clearTags();
    var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.notifyObservers(null,"ext:delicious:sidebarReloadTagsRequest","");
}

function clearFeeds()
{
    var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
    clearTree(tree);
}

/**
 * Reloads the selected feeds
 */
function reloadFeeds()
{
    var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var datasources = tree.database.GetDataSources();
    
    alert("Reload is not working currently. 304 HTTP code is not handled correctly by Mozilla.\nWorking on a fix.");
    
    // Possible solution??
    while(datasources.hasMoreElements())
    {
            var datasource = datasources.getNext();
            datasource = datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
            // reload asyncronously. Does not seem to know what 304 is
            datasource.Refresh(false);
    }
}

/**
 * Queries the selected tags and loads the results into the bookmark list.
 */
function loadSelectedTag()
{
    const tagsTree = document.getElementById('delicious-sidebar-tags-tree');
    if(tagsTree.view.selection.count == 0)
    {
        alert("No tags selected to query");
        return false;
    }
    else
    {
        window.status="Loading tags...";
        var start = new Object();
        var end = new Object();
        var numRanges = tagsTree.view.selection.getRangeCount();
        var tags = "";

        // Discontiguous selections are broken up into ranges, so 
        // we loop over each range in turn.
        for(var t=0;t<numRanges;t++)
        {
            tagsTree.view.selection.getRangeAt(t,start,end);
            for(var v=start.value;v<=end.value;v++)
                tags+=tagsTree.view.getCellText(v, "name_column") + "+";
                // Once the RSS feed is fixed, this needs to be enabled
                // in order to allow tags like "C++".
                //tags+="\""+tagsTree.view.getCellText(v, "name") + "\"+";
        }

        tags=tags.substring(0,tags.length-1);

        loadFeed(tags);
        window.status="Done";
        return true;
    }
}

/**
 * Query del.icio.us for bookmarks under the specified tags and load
 * the tags into the bookmarks tree.
 */
function loadFeed(tags)
{
    try
    {
        var username = gUsername;
        var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
        var feedUrl = "http://del.icio.us/rss/" + username;
        
        if(tags != null)
        {
            feedUrl += "/" + encodeURIComponent(tags);
        }

        var datasource = rdfService.GetDataSource(feedUrl);
        
        var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
        
        // This has to match the channel in the feed
        tree.ref = "http://del.icio.us/" + username + "/" + tags;
        tree.database.AddDataSource(datasource);
        tree.builder.rebuild();
    }
    catch(e) { alert(e); }
}

//
// Load link
//
function openSingleBookmark()
{
    var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var bookmarkUrl = tree.view.getCellText(tree.currentIndex, "link_column");
    window._content.document.location.href = bookmarkUrl;
    return;
}

function openMultipleBookmarks()
{
    // There has to be an easier way to open a new tab, but
    // the getBrowser().addTab(url) I see elsewhere doesn't work here.
    var winMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var winEnumerator = winMediator.getZOrderDOMWindowEnumerator('navigator:browser', false);
    var window = winEnumerator.getNext();

    const bmsTree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var start = new Object();
    var end = new Object();
    var numRanges = bmsTree.view.selection.getRangeCount();
    var tags = "";
    var first = true;

    for(var t=0;t<numRanges;t++)
    {
        bmsTree.view.selection.getRangeAt(t,start,end);
        for(var v=start.value;v<=end.value;v++)
        {
            var bookmarkUrl = bmsTree.view.getCellText(v, "link_column");
            if(first)
            {
                window._content.document.location.href = bookmarkUrl;
                first=false;
            }
            else window.getBrowser().addTab(bookmarkUrl);
        }
    }

    return;
}

//
// Rename tag
//
function renameTag()
{
    const tagsTree = document.getElementById('delicious-sidebar-tags-tree');
    const tag = tagsTree.view.getCellText(tagsTree.currentIndex, "name_column");
    const count = tagsTree.view.selection.getRangeCount();
    
    if(count == 0)
    {
        alert("No tag selected to rename");
        return false;
    }
    else
    {
        var name = prompt("Enter new name for tag '" + tag + "'");
        if(name.length > 0)
        {
            var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
            observerService.notifyObservers(null,"ext:delicious:sidebarRenameTagRequest","from:"+tag+"&&__to:"+name);
            return true;
        }
        else
        {
            return false;
        }
    }
}

//
// Removes all datasources from a tree
//
function clearTree(tree)
{
    var datasources = tree.database.GetDataSources();
    while(datasources.hasMoreElements()){
            var datasource = datasources.getNext();
            datasource = datasource.QueryInterface(Components.interfaces.nsIRDFDataSource);
            tree.database.RemoveDataSource(datasource);
    }

    tree.builder.rebuild();
}

